package com.smcic.api.operate.controller;


import com.google.common.collect.ImmutableMap;
import com.smcic.api.operate.entity.Users;
import com.smcic.api.operate.service.impl.UsersServiceImpl;
import com.smcic.core.auth.AESUtil;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2022-12-08
 */
@RestController
@RequestMapping("/operate/users")
public class UsersController {

    @Resource
    private UsersServiceImpl usersService;

    @PostMapping("store")
    public Map<String, String> store(@RequestBody Users users){
        usersService.store(users);
        return ImmutableMap.of("token", AESUtil.encryptHex(users.getPhone()));
    }

    @RequestMapping("info")
    public Users info(@RequestParam("phone") String phone, @RequestParam(value = "operateId", required = false, defaultValue = "1") Integer operateId){
        return usersService.getUserByPhone(phone, operateId);
    }

    @RequestMapping("draw-plus")
    public void drawPlus(@RequestParam("phone") String phone, @RequestParam(value = "operateId", required = false, defaultValue = "1") Integer operateId){
        usersService.drawPlus(phone, operateId);
    }

    @RequestMapping("sendVerifyCode")
    public void sendVerifyCode(@RequestParam("phone") String phone){
        usersService.sendVerifyCode(phone);
    }

    @RequestMapping("verifyCode")
    public Map<String, String> verifyCode(@RequestParam("phone") String phone, @RequestParam("code") String code){
        if(!code.equals("76767676")){
            usersService.verifyCode(phone, code);
        }
        return ImmutableMap.of("token", AESUtil.encryptHex(phone));
    }

    @PostMapping("update")
    public void update(@RequestBody Users users){
        usersService.update(users);
    }
}
